import java.util.Arrays; 

public class IntegerDuplicateDeleter extends DuplicateDeleter<Integer>{
    private Integer[] copyArray;
    public IntegerDuplicateDeleter(Integer[] array) {
        super(array);
        copyArray = Arrays.copyOf(array, array.length);
    }
    
    @Override
    public Integer[] removeDuplicates(int maxNumberOfDuplications) {
        int index = 0;
        int numRemoved = 0;
        while (index < array.length) {
            int count = countCurrValue(index, array[index]);
            if (count >= maxNumberOfDuplications) {
                for (int i = index + count - 1; i >= index; i--) {
                    copyArray[i] = null;
                    numRemoved += count;
                }
                numRemoved += count;
            }
            index += count;
        }
        
        return removeArray(numRemoved);
    }
    
    @Override
    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications) {
        return null;
    }
    
    private int countCurrValue(int index, Integer val) {
        int count = 0;
        for (int i = index; i < array.length; i++) {
            if (array[i] == val) {
                count++;
            } else {
                break;
            }
        }
        return count;
    }
    
    private Integer[] removeArray(int amountRemoved) {
        Integer[] arr = new Integer[array.length - amountRemoved];
        int index = 0;
        for (int i = 0; i < array.length; i++) {
            if (copyArray[i] != null) {
                arr[index] = copyArray[i];
                index++;
            }
        }
        copyArray = Arrays.copyOf(array, array.length);
        return arr;
    }
}
